'''
Conway's game of life, step 2
showing cell surroundings (diagnostics only)
'''

board_rows = [
           "....................",
           "....#...............",
           ".....#..............",
           "...###..............",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "#...................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "...................."
       ]

def count_surrounding_first_attempt(row, col, board):
    count = 0
    rows = len(board)
    cols = len(board[0])
    for r in range(row-1, row+2): #----------
        for c in range(col-1, col+2): #----------
            if board[r][c] == "#":
                count += 1
    return count

def count_surrounding_second_attempt(row, col, board):
    count = 0
    rows = len(board)
    cols = len(board[0])
    for r in range(row-1, row+2): #----------
        for c in range(col-1, col+2): #----------
            if not (r == row and c == col):  #skip cell in question
                if board[r][c] == "#":
                    count += 1
    return count

def count_surrounding(row, col, board):
    count = 0
    rows = len(board)
    cols = len(board[0])
    for r_pos in range(row-1, row+2): #----------
        r = r_pos % rows
        for c_pos in range(col-1, col+2): #----------
            c = c_pos % cols
            if not (r == row and c == col):  #skip cell in question
                if board[r][c] == "#":
                    count += 1
    return count

def init_board(board_rows):
    new_board = []
    for row in board_rows:
        new_row = []
        for column in range(len(row)):
            #print(row[column],end="")
            new_row.append(row[column])
        #print()
        new_board.append(new_row)
    return new_board

def print_board(board):
    for row in board:
        for cell in row:
            print(cell,end="")
        print()

def print_surrounding(board):
    rows = len(board)
    cols = len(board[0])
    for row in range(rows):
        for col in range(cols):
            print(count_surrounding(row, col, board),end="")
        print()

# main program:
board = init_board(board_rows)
print_board(board)
print()
print_surrounding(board)




