'''
Conway's game of life, step 4
add lifecycle and show 	animation											
'''

board_rows = [
           "....................",
           "....#...............",
           ".....#..............",
           "...###..............",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "....................",
           "...................."
       ]

def lifecycle(board_before):
    rows = len(board_before)
    cols = len(board_before[0])
    board_after = []
    for row in range(rows):         # initialize after
        board_after.append(list("."*cols))
    for row in range(rows):
        for col in range(cols):
            num_surr = count_surrounding(row, col, board_before)
            if board_before[row][col] == "#" and num_surr < 2:
                board_after[row][col] = "."
            elif board_before[row][col] == "#" and num_surr > 3:
                board_after[row][col] = "."
            elif board_before[row][col] == "." and num_surr == 3:
                board_after[row][col] = "#"
            else:
                board_after[row][col] = board_before[row][col]
    return board_after

def count_surrounding(row, col, board):
    count = 0
    rows = len(board)
    cols = len(board[0])
    for r_pos in range(row-1, row+2): #----------
        r = r_pos % rows
        for c_pos in range(col-1, col+2): #----------
            c = c_pos % cols
            if not (r == row and c == col):  #skip cell in question
                if board[r][c] == "#":
                    count += 1
    return count

def init_board(board_rows):
    new_board = []
    for row in board_rows:
        new_row = []
        for column in range(len(row)):
            #print(row[column],end="")
            new_row.append(row[column])
        #print()
        new_board.append(new_row)
    return new_board

def print_board(board):
    for row in board:
        for cell in row:
            print(cell,end="")
        print()

# main program:		   
board = init_board(board_rows)
print_board(board)
print()

for i in range(0,50):
    board = lifecycle(board)
    #print_board(board)
    #print()
print_board(board)



